

function [resultat,x,y]=GA_optimal_KB_dimensjonering(MVA,ssk,generatorer,linjer,GA_parametre, kostnadsparametre, dagens_drift,generatortyper...
        ,generatordata_tapsberegning,variasjon_aar_last,variasjon_dogn_last,lastkategori,variasjon_aar_produksjon,maaned,time)

tic;

%%
%--------------------Overfrer data fra innleste filer til variabler

%-----------------------GA_parametre-------------------------------

populasjon=GA_parametre(1,1);
generasjoner=GA_parametre(2,1);
mutasjonsRate=GA_parametre(3,1);

keep_rate=GA_parametre(4,1);
antall_i_maxmatrise=populasjon*keep_rate;

crossover_rate=GA_parametre(5,1);
cross1=populasjon*(1-crossover_rate)/2;
antall_kopieres=round(cross1)*2;

trinnstorrelse=GA_parametre(6,1);

utgangskostnad=GA_parametre(7,1); 

spenningskostnad=GA_parametre(9,1);



%%
%--------------------Inndata til kostnadsberegninger-------------
%

kapitaliseringsfaktor=kostnadsparametre(1,1);
drift_og_vedl=kostnadsparametre(2,1); 

invest_KB_fast=kostnadsparametre(3,1);     
invest_KB_var=kostnadsparametre(4,1);        
invest_bryterf_fast=kostnadsparametre(5,1); 

KB_fast=invest_KB_fast*(1+drift_og_vedl*kapitaliseringsfaktor/100);
KB_var=invest_KB_var*(1+drift_og_vedl*kapitaliseringsfaktor/100);
bryterf_fast=invest_bryterf_fast*(1+drift_og_vedl*kapitaliseringsfaktor/100);


KS_pris=kostnadsparametre(6,1);
KS_ekvpris=KS_pris*kapitaliseringsfaktor; 

ekv_energipris_gen=kostnadsparametre(7,1); %Ekvivalentpris tap i generatorer kr/kWh
brukstid_gen=kostnadsparametre(8,1);      %Brukstid per r for tapendring i tunglast for tap i generatorer 
gen_ekvpris=ekv_energipris_gen*brukstid_gen*kapitaliseringsfaktor;  %Antar konstant pris, kostant brukstid og konstant tapsendring. Kostnadsreduksjon ved tapsendring kr/kW

ekvkostnad_effekttap=kostnadsparametre(9,1);   %Hentet fra Planbok. kr/kW
ekvkostnad_energitap=kostnadsparametre(10,1);  %Ekvivalentpris for tap i nett. kr/kWh
brukstid_nett=kostnadsparametre(11,1);         %Brukstid per r for tapendring i tunglast for tap i nett 
tap_ekvpris_aar=ekvkostnad_effekttap+ekvkostnad_energitap*brukstid_nett; %kr/kWh

tap_ekvpris=tap_ekvpris_aar*kapitaliseringsfaktor*1000; %Antar konstant pris, konstant brukstid og konstant tapsendring. Kostnadsreduksjon ved tapsendring kr/MWh

Snett_pris=kostnadsparametre(12,1); %Pris fra sentralnettstariffen. kr/MVAr betalt til Statnett for reaktivt uttak i tunglast.
Snett_ekvpris=Snett_pris*kapitaliseringsfaktor;

%---------------------------Dagens nett---------------------------

effekttap_dagens_tunglast=dagens_drift(1,1); 
generatortap_dagens_tunglast=dagens_drift(2,1);  
Snett_dagens_tunglast=dagens_drift(3,1);  
reaktiv_prod_i_gen_dagens_tunglast=dagens_drift(4,1); 

%%
%-------Legger inn variasjonsdata----------------------------
%
%Legger inn data om variasjon i nettet og justerer last og produksjon til
%nsket tid p ret.

type_dogn=1; %Default dgntype er virkedag i vinterlast

%------Legger inn data i funksjonene og justerer lasten og produksjonen 

ssk=juster_lasten(ssk,variasjon_aar_last,variasjon_dogn_last,maaned,time,lastkategori,type_dogn);

generatorer=juster_produksjonen(generatorer,variasjon_aar_produksjon,maaned);


%%
%--------------------LEGGER INN NETTDATA----------------------------------%
%
%lager en matrise med oversikt over hvilke generatorer/KB som inngr i
%optimaliseringen. Henter vre og nedre grense for reaktiv produksjon for
%hver generator/KB (gen)

gen_storrelse=size(generatortyper);
antallGener=gen_storrelse(1,1);


gen_nr=zeros(1,antallGener);
gen_typ=zeros(1,antallGener);
gen_grenser=zeros(2,antallGener);

for i=1:antallGener

gen_nr(1,i)=generatortyper(i,1);   
gen_typ(1,i)=generatortyper(i,2);
   
gen_grenser(1,i) = generatorer(gen_nr(i),5);
gen_grenser(2,i) = generatorer(gen_nr(i),4);

end
       
disp(gen_grenser)


%%
%------------LAGER MATRISE SOM LAGRER BESTE RESULTAT FOR HVER GENEREASJON--
%
%

beste_resultater=zeros(2,generasjoner);

%%
%-------INITIERER KROMOSOMMATRISEN OG LEGGER INN TILFELDIGE VERDIER--------%
%
%Legger inn tilfeldige verdier i kromosommatrisen. 
%

[kromosomer,suksess] = lageTilfeldigStartkromosom(gen_grenser,trinnstorrelse,antallGener,populasjon,MVA,ssk,generatorer,linjer,gen_nr,gen_typ,utgangskostnad...
                                        ,KB_fast, KB_var, bryterf_fast, KS_ekvpris, gen_ekvpris, tap_ekvpris, Snett_ekvpris, spenningskostnad...
                                        ,effekttap_dagens_tunglast,generatortap_dagens_tunglast,Snett_dagens_tunglast,reaktiv_prod_i_gen_dagens_tunglast...
                                        ,generatordata_tapsberegning);
if suksess==1

%%
%-----------LEGGER INN EN FOR LKKE MED REPETISJON LIK ANTALL EVOLUSJONER--%
%
%Optimaliseringen starter her. 

for p=1:generasjoner

disp('--------------Ny generasjon---------')
    
disp('Generasjon nr')
disp(p)

%%
%-----------------SJEKKE OM DET FINNES LIKE KROMOSOMER I POPULASJONEN-----
%
%

sorterte_kromosomer = sorter_like_kromosomer(kromosomer,populasjon);


%%
%----------------BEREGN FITNESSVERDI----------------------%
%
%Beregner fitness til alle forskjellige kromosomer. Unngr  beregne fitnessverdi til like kromosomer ved hjelp av matrisen
%sorterte kromosomer.
%

c=1;
fitness=zeros(populasjon,1);
fitness_max=zeros(populasjon*keep_rate,1);
kromo_max=zeros(populasjon*keep_rate,antallGener);

while sorterte_kromosomer(c,1)~=0
    plassering_en=sorterte_kromosomer(c,1);
    kromosom=kromosomer(plassering_en,:);
    fitness_ut=beregnFitness_for_enkelt_kromosom(MVA,ssk,generatorer,linjer,kromosom, gen_nr, gen_typ, antallGener,utgangskostnad...
                                                 ,KB_fast, KB_var, bryterf_fast, KS_ekvpris, gen_ekvpris, tap_ekvpris, Snett_ekvpris, spenningskostnad...
                                                 ,effekttap_dagens_tunglast,generatortap_dagens_tunglast,Snett_dagens_tunglast,reaktiv_prod_i_gen_dagens_tunglast...
                                                 ,generatordata_tapsberegning);
    d=1;
    while sorterte_kromosomer(c,d)~=0
    plassering=sorterte_kromosomer(c,d);
    fitness(plassering,1)=fitness_ut;
    d=d+1;
    end
    c=c+1;
    if c>populasjon
        break
    end
end


for i=1:populasjon
    for a=1:populasjon*keep_rate   
            if fitness(i,1)>=fitness_max(a,1)
                
                %Flytter drligere fitnessverdier ett hakk ned i matrisen
                %og gjr plass for ny fitnessverdi
                for b=((populasjon*keep_rate)-a):-1:1
                fitness_max(a+b,1)=fitness_max(a+b-1,1);
                end

                %Setter ny fitnessverdi inn i matrisen
                fitness_max(a,1)=fitness(i,1);
                
                %Flytter drligere kromosomer ett hakk ned i matrisen
                %og gjr plass for nytt kromosom
                
                for b=((populasjon*keep_rate)-a):-1:1
                    for j=1:antallGener
                    kromo_max(a+b,j)=kromo_max(a+b-1,j);
                    %kromo_max_plassering(a+b,1)=kromo_max_plassering(a+b-1,1);
                    end
                end
                
                %Setter inn nytt kromosom
                for j=1:antallGener
                kromo_max(a,j)=kromosomer(i,j);
                %kromo_max_plassering(a,1)=i;
                end

                break
            end
    end
end

%%
%-----------------------------SKRIVER UT DE BESTE KROMOSOMENE-------------
%

if antall_i_maxmatrise>=15
    kromo_max_utskrift=zeros(15,antallGener);
    fitness_max_utskrift=zeros(15,1);
    for i=1:15
        for j=1:antallGener
        kromo_max_utskrift(i,j)=kromo_max(i,j);
        end
        fitness_max_utskrift(i,1)=fitness_max(i,1);
    end
else
    kromo_max_utskrift=zeros(antall_i_maxmatrise,antallGener);
    fitness_max_utskrift=zeros(antall_i_maxmatrise,1);
    for i=1:antall_i_maxmatrise
        for j=1:antallGener
        kromo_max_utskrift(i,j)=kromo_max(i,j);
        end
        fitness_max_utskrift(i,1)=fitness_max(i,1);
    end
end
    
disp('Her er maksimal fitnessverdi:')
disp(fitness_max_utskrift)

disp('Her er de beste lsningene:')
disp(kromo_max_utskrift)

beste_resultater(1,p)=p;
beste_resultater(2,p)=fitness_max(1,1);


%%
%------------------BEREGNE PLASS P RULETTHJUL-----------------------------%

%skritt 1: beregne populasjonens totale fitnessverdi%

totalverdi = beregnePopulasjonensTotaleFitnessverdi(fitness,populasjon);

%skritt 2: beregne andel av totalfitness per kromosom%

fitnessAndel=beregneAndel(fitness,totalverdi,populasjon);

%skritt 3: lage plasser p ruletthjul%

fitnessAndelAkkumulert=lagePlasserPaaRuletthjul(fitnessAndel,populasjon);


%%
%-------------------------REPRODUKSJON-------------------------------------%
%
%Det gamle kromosomet blir reprodusert basert p fitnessverdien til hvert
%av kromosomene i den opprinnelige populasjonen. Her er den gamle
%kromosommatrisen spart til fitnessberegningene under, men i prinsippet br
%kromosom settes lik reprodusert kromosom etter at reproduksjonen er gjort
%

reprodusertKromosom = reproduser(kromosomer,fitnessAndelAkkumulert,antallGener,populasjon,kromo_max,keep_rate);


%%   
%---------------BEREGNER FITNESSVERDI FR OG ETTER REPRODUKSJON------------%
%
%Denne delen er ikke ndvendig for at programmet skal fungere, med det kan
%vre en nyttig  beregne fitnessverdien fr og etter reproduksjon.
%P denne mten kan det verifiseres at fitnessverdien til den nye
%populasjonen faktisk ker etter reproduksjonen, og at rulletthjulmetoden
%dermed fungerer.
%

%fitnessGamleKromosomer = beregnFitnessKB(MVA, ssk, generatorer, linjer, kromosomer, gen_nr, gen_typ, antallGener, populasjon);
%fitnessReproduserteKromosomer = beregnFitnessKB(MVA, ssk, generatorer, linjer, reprodusertKromosom, gen_nr, gen_typ, antallGener, populasjon);

%totalFitnessGammelPopulasjon = beregnePopulasjonensTotaleFitnessverdi(fitnessGamleKromosomer,populasjon);
%totalFitnessReprodusertPopulasjon = beregnePopulasjonensTotaleFitnessverdi(fitnessReproduserteKromosomer,populasjon);

%disp('dette er det gamle kromosomet')

%disp(kromosomer)

%disp('dette er det reproduserte kromosomet')

%disp(reprodusertKromosom)

kromosomer=reprodusertKromosom;



%%
%----------------LAGER MATRISE MED HVILKE PAR SOM SKAL KRYSSES-------------%
%
%Denne funksjonen er veldig nyttig og kan brukes p alle problemer.
%Matrisen inneholder tilfeldig valgte kromosompar som skal krysses. N
%gjenstr det bare  velge et tilfeldig krysningspunkt. 

[parMatrise,restMatrise]=lagParMatrise(populasjon,keep_rate,antall_kopieres);


%%
%--------------------------KRYSSER KROMOSOMER------------------------------%
%
%Denne funksjonen krysser kromosomene i den reproduserte kromosommatrisen.
%Funksjonen inneholder bde tilfeldig bestemmelse av krysningspunkt,
%innlesning av parMatrise og kromosommatrise. Funksjonen leverer ut den
%kryssede matrisen.
% 

crossover = kryssKromosomer(kromosomer, parMatrise, restMatrise, antallGener, populasjon);

kromosomer=crossover;


%%
%--------------------------MUTASJON---------------------------------------%
%
%For  sikre at muligheter som kan ha falt bort evoulsjonsprosessen m det
%legges inne en mulighet for at genene i kromosomet kan mutere.
%Mutasjonssannsynligheten kan eventuelt legges inn i begynnelsen av
%programmet som en parameter p linje med antall evoulsjoner.
%

muterteKromosomer1 = muter_kromosomer_gi_helt_ny_verdi(kromosomer, mutasjonsRate, trinnstorrelse, antallGener, populasjon, gen_grenser, keep_rate);

kromosomer=muterteKromosomer1;

muterteKromosomer2 = muter_kromosomer_endre_verdi_skrittvis(kromosomer, mutasjonsRate, trinnstorrelse, antallGener, gen_grenser, populasjon, keep_rate);

kromosomer=muterteKromosomer2;

%%  
%%
%----------------------HER SLUTTER EVOLUSJONS-LKKA------------------------%
%
%Kryssingen er foretatt og prosessene kan kjres p nytt. 

end


sluttkromosom=kromo_max_utskrift(1,:);


[tap,kostnadsred_nettap,gentap,kostnadsred_gentap,Snett,kostnadsred_snett,investkost_KB,kostnadsred_KS,fitness,straffekost_spenning] = ...
                                                            skriv_ut_beste_resultat_tunglast(MVA,ssk,generatorer,linjer,sluttkromosom, gen_nr, gen_typ, antallGener,utgangskostnad...
                                                            , KB_fast, KB_var, bryterf_fast, KS_ekvpris, gen_ekvpris, tap_ekvpris, Snett_ekvpris, spenningskostnad...
                                                            ,effekttap_dagens_tunglast,generatortap_dagens_tunglast,Snett_dagens_tunglast,reaktiv_prod_i_gen_dagens_tunglast...
                                                            ,generatordata_tapsberegning);
                                                        
resultat=fitness;                                                      

toc;

tid=toc;

disp('Programmet brukte:')
disp(tid)

if straffekost_spenning==0
    disp('Alle spenningsverdier er innefor tillatte grenser')
    disp(' ')

disp('------------------- Kostnadsreduksjoner -----------------------------------')
disp(' ')
disp('Nettap ved tunglast er:')
disp(tap)
disp('Reduserte kostnader til nettap er:')
disp(kostnadsred_nettap)
disp('Generatortap ved tunglast er:')
disp(gentap)
disp('Reduserte kostnader til generatortap er:')
disp(kostnadsred_gentap)
disp('Reaktivt uttak fra sentralnettet ved tunglast er:')
disp(Snett)
disp('Reduserte kostnader til sentralnettsuttak er:')
disp(kostnadsred_snett)

disp('Reduserte kostnader til kjp av reaktiv effekt fra kraftstasjoner er:')
disp(kostnadsred_KS)

disp('Kostnader til installasjon, drift og vedlikehold av kondensatorbatterier er:')
disp(investkost_KB)

disp('Totale kostnadsreduksjoner er:')

tot_kostnadsred=fitness-utgangskostnad;

disp(tot_kostnadsred)

else
    disp('Ikke alle spenningsverdier er innefor tillatte grenser')
    disp('Gjenta optimaliseringen med en hyere straffekostnad for uakseptable spenningsverdier')
end


x=beste_resultater(1,:);
y=beste_resultater(2,:);

plot(x,y)

elseif suksess==0
    disp('Det tar for lang tid  lage kromosomer til startpopulasjonen fordi mange kromosomer fr fitnessverdi mindre enn 0.')
    disp('Prv p nytt men en lavere spenningskostnad eller en hyere utgangskostnad for  lse dette problemet')                                    
end
    
return;