function [fitness] = beregnFitness_utenom_tunglast(MVA,ssk,generatorer,linjer,kromo, gen_nr, gen_typ, gener,tapstak...
                                                   ,spenningskostnad,generatordata_tapsberegning)

 
%%
%-----------------Beregning av tap i generatorer-----------------------
%

totale_generatortap=0;

for i=1:gener
    if gen_typ(1,i)==1
        generator_nummer=gen_nr(1,i);
        aktiv_produksjon=generatorer(generator_nummer,2);
        reaktiv_produksjon=kromo(i);
        generatortap=tap_i_generatorer(aktiv_produksjon,reaktiv_produksjon,generator_nummer,generatordata_tapsberegning);
        totale_generatortap=totale_generatortap+generatortap; %tap i kW
    end    
end

totale_generatortap=totale_generatortap/1000;

%%
%----------------------TAPSKOSTNADER OG SENTRALNETTSKOSTNADER--------------
%
%Kjrer lastflyt og henter ut verdier til beregning av kostnader.
%
%Legger frst inn verdier for reaktiv produksjon i generator-matrisen som brukes
%i lastflytberegningen.

for j=1:gener
    generatorer(gen_nr(j),3)=kromo(j);
end

%Kjrer lastflytberegning. 

[baseMVA_ut,bus_ut,gen_ut,branch_ut,success_ut,et_ut,tap_ut]=runpf_mod(MVA,ssk,generatorer,linjer);

%Lagrer informasjon om konvergens i lastflyten

success=success_ut;

%Beregner tapskostnader

nettap=tap_ut;

%Beregner sentralnettskostnader
     
ssk_matrise=size(ssk);
antall_ssk=ssk_matrise(1,1);

%Finner antall samleskinner hvor spenningen er utenfor grensene

spenningsfeil=0;
    
for a=1:antall_ssk
    if bus_ut(a,8)>bus_ut(a,12) || bus_ut(a,8)<bus_ut(a,13)
       spenningsfeil=spenningsfeil+1;
    end
end

%Beregner totale kostnader. Hvis kostnadene er lavere enn kostnadstaket og
%hvis lastflyten konvergerte blir fitnessverdien beregnet. Hvis ikke settes
%fitnessverdien til null.

if success==1  
    fitness=tapstak-nettap-totale_generatortap-(spenningsfeil*spenningskostnad);
else
    fitness=0;
end
    
return;
