function [baseMVA, bus, gen, branch, areas, gencost] = kongsbergnett
%CASE9    Power flow data for 9 bus, 3 generator case.
%   Please see 'help caseformat' for details on the case file format.
%
%   Based on data from Joe H. Chow's book, p. 70.

%   MATPOWER
%   $Id: case9.m,v 1.7 2007/09/17 16:07:48 ray Exp $

%%-----  Power Flow Data  -----%%
%% system MVA base
baseMVA = 10;

%% bus data
%	bus_i	type	Pd      Qd      Gs	Bs	area	Vm	Va	baseKV	zone        Vmax	Vmin
bus = [
    1       3       0       0       0	0	1       1	0	60.00        1        1.1     0.8;
	2       2       0	    0	    0	0	1       1	0	60.00        1        1.1     0.8;
	3       1       7.177   1.457   0	0	1       1	0	60.00        1        1.1     0.8;
	4       2       0       0       0   0   1       1   0   60.00        1        1.1     0.8;
    5       2       0       0       0   0   1       1   0   60.00        1        1.1     0.8;
    6       1       0       0       0	0	1       1	0	6.0          1        1.1     0.8;
    7       1       4.709   1.453  0	0	1       1	0	11.7         1        1.1     0.8;
    8       1       1.677   0.017  0	0	1       1	0	21.8         1        1.006   0.967;
    9       1       7.774   1.579   0	0	1       1	0	21.8         1        1.1     0.8;
    10      1       0       0       0	0	1       1	0	4.8          1        1.1     0.8;
    11      1       8.863   2.844   0	0	1       1	0	11.4         1        1.1     0.8;
    12      1       6.645   2.080    0	0	1       1	0	11.3         1        1.1     0.8;
    13      1       16.296  3.309    0	0	1       1	0	11.1         1        1.1     0.8;
    14      1       0       0       0	0	1       1	0	11.1         1        1.1     0.8;
    15      1       0       0       0	0	1       1	0	3.5          1        1.1     0.8;
    ];
%% generator data
%	bus	Pg      Qg      Qmax	Qmin        Vg	mBase	status	Pmax	Pmin
gen = [
    1	0       0       50       -50        1	10          1	 100     -100;
    6   12.5    1.5     1.5      -2         1   10          1    12.5    0;  %Vrenga
    10  16.5    0      8         -2         1   10          1    16.5    0;  %Pikerfoss
    15  16.5    0      5.5       -3         1   10          1    16.5    0; %Gamlebrofoss
    7   0       0      15        0          1   10          1    0       0; %Stengelsrud 11 kV
    8   0       0      15        0          1   10          1    0       0; %Stengelsrud 22 kV
    11  0       0      15        0          1   10          1    0       0; %Glabak T1
    12  0       0      15        0          1   10          1    0       0; %Glabak T2
    13  0       0      15        0          1   10          1    0       0; %Gomsrud 11 kV
    ];


%% branch data
%	fbus	tbus	r           x           b           rateA	rateB	rateC	ratio       angle	status
branch = [
	1       2       0.01015      0.0172      0.02824     100     100     100        0            0       1;
    1       2       0.01015      0.0172      0.02824     100     100     100        0            0       1;
    2       3       0.026062    0.027382    0.04785 	100     100     100        0            0       1;
   	2       4       0.003231    0.004092    0.00703     100     100     100        0            0       1;
   	4       5       0.000866    0.000829	0.07853     100     100     100        0            0       1;
    3       6       0.000000    0.028155	0           100     100     100        0            0       1;
    2       7       0.005655    0.087299	0           100     100     100        0            0       1;
    2       8       0.002252    0.035801	0           100     100     100        0            0       1;
    8       9       0.007283    0.016753	0.0035      100     100     100        0            0       1;
    9      10       0.003787    0.047007	0           100     100     100        0            0       1;
    4      11       0.002723    0.046512	0           100     100     100        0            0       1;
    4      12       0.000000    0.038312	0           100     100     100        0            0       1;
    5      13       0.005049    0.089239	0           100     100     100        0            0       1;
    13     14       0.000900    0.01043     0.00793     100     100     100        0            0       1;
    14     15       0.001044    0.036489	0           100     100     100        0            0       1;
   ];

%%-----  OPF Data  -----%%
%% area data
areas = [
	1	1;
];

%% generator cost data
%	1	startup	shutdown	n	x1	y1	...	xn	yn
%	2	startup	shutdown	n	c(n-1)	...	c0
gencost = [
    	];

return;
