function [baseMVA, bus, gen, branch, areas, gencost] = modumnett_ver2
%CASE9    Power flow data for 9 bus, 3 generator case.
%   Please see 'help caseformat' for details on the case file format.
%
%   Based on data from Joe H. Chow's book, p. 70.

%   MATPOWER
%   $Id: case9.m,v 1.7 2007/09/17 16:07:48 ray Exp $

%%-----  Power Flow Data  -----%%
%% system MVA base
baseMVA = 10;


%% bus data
%	bus_i	type	Pd      Qd      Gs	Bs	area	Vm	Va	baseKV	zone        Vmax	Vmin
bus = [
    1       3       0       0       0	0	1       1	0	60.00        1        1.1     0.8;  %Flesaker 60 kV
	2       1       0	    0	    0	0	1       1	0	60.00        1        1.1     0.8;  %Vestfossen avgr 60 kV
	3       1       0       0       0	0	1       1	0	60.00        1        1.1     0.8;  %Vestfossen 60 kV
	4       1       11.408  -0.5    0   0   1       1   0   22.385       1        1.1     0.8;  %Vestfossen 22 kV
    5       1       0       0       0   0   1       1   0   60.00        1        1.1     0.8;  %Hokksund avgr (Sem) 60 kV
    6       1       0       0       0	0	1       1	0	60.00        1        1.1     0.8;  %Hokksund 60 kV
    7       1       25.296  5.137   0	0	1       1	0	22.759       1        1.1     0.8;  %Hokksund T1 22 kV
    8       1       20.032  4.068   0	0	1       1	0	22.579       1        1.1     0.8;  %Hokksund T2 22 kV
    9       1       0       0       0	0	1       1	0	60.00        1        1.1     0.8;  %Skotselv avgr 60 kV
    10      1       0       0       0	0	1       1	0	60.00        1        1.1     0.8;  %Skotselv 60 kV
    11      1       6.693   1.359   0	0	1       1	0	22.227       1        1.1     0.8;  %Skotselv 22 kV
    12      1       0       0       0	0	1       1	0	60.00        1        1.05    0.8;  %Setersberg 60 kV
    13      1       5.4     1.097   0	0	1       1	0	21.698       1        1.075   0.8;  %Setersberg 22 kV
    14      1       13.47   2.735   0	0	1       1	0	21.698       1        1.075   0.8;  %Dvikfoss 22 kV
    15      1       0       0       0	0	1       1	0	4.7341       1        1.1     0.8;  %Dvikfoss GE
    16      1       0       0       0	0	1       1	0	60.00        1        1.1     0.8;  %Embretsfoss avgr 60 kV
    17      1       0       0       0	0	1       1	0	60.00        1        1.1     0.8;  %Embretsfoss 60 KV
    18      1       0       0       0	0	1       1	0	10.66        1        1.1     0.8;  %Embretsfoss GE
    19      1       0       0       0	0	1       1	0	60.00        1        1.1     0.8;  %Holgersmoen 60 kV
    20      1       0.48    0.097   0	0	1       1	0	60.00        1        1.1     0.8;  %Geithusfoss 60 kV
    21      1       0       0       0	0	1       1	0	6.6          1        1.1     0.8;  %Geithusfoss GE
    22      1       0       0       0	0	1       1	0	60.00        1        1.1     0.8;  %Hovde 60 kV
    23      1       25.2    5.117   0	0	1       1	0	21.818       1        1.1     0.8;  %Hovde 22 kV
    24      1       3       0.5       0	0	1       1	0	60.00        1        1.042     0.8;  %Ramfoss 60 kV
    25      1       7.4     1.503   0	0	1       1	0	22.00        1        1.1     0.8;  %Ramfoss LA 22 kV
    26      1       0       0       0	0	1       1	0	10.00        1        1.05     0.8;  %Ramfoss GE 1
    27      1       0       0       0	0	1       1	0	10.00        1        1.05     0.8;  %Ramfoss GE 2
    28      1       0       0       0	0	1       1	0	10.00        1        1.05     0.8;  %Ramfoss GE 3
    ];
%% generator data
%	bus	Pg      Qg      Qmax	Qmin        Vg	mBase	status	Pmax	Pmin
gen = [
    1	0       0       50       -50        1	10         1	100     -100;
    7   0      7.1     7.1      7.1         1   10         1    0       0;          %Hokksund T1 KB
    15  14.3    1       6        -2         1   10         1    14.3    0;          %Dvikfoss GE 
    18  3       0       2      -0.5         1   10         1    3       0;          %Embretsfoss GE 1
    18  3       0       2      -0.5         1   10         1    3       0;          %Embretsfoss GE 2
    18  3       0       2      -0.5         1   10         1    3       0;          %Embretsfoss GE 3
    18  18.5    3       8        -2         1   10         1    18.5    0;          %Embretsfoss GE 4
    21  13      1       8        -2         1   10         1    13      0;          %Geithusfoss GE
    26  10      1       8        -1         1   10         1    10      0;          %Ramfoss GE 1
    27  10      1       8        -1         1   10         1    10      0;          %Ramfoss GE 2
    28  10      1       8        -1         1   10         1    10      0;          %Ramfoss GE 3
     4  0       0      20        0          1   10         1    0       0;          %KB Vestfossen 22 kV
     7  0       0      20        0          1   10         1    0       0;          %KB Hokksund T1 22 kV
     8  0       0      20        0          1   10         1    0       0;          %KB Hokksund T2 22 kV
    11  0       0      20        0          1   10         1    0       0;          %KB Skotselv 22 kV
    13  0       0      20        0          1   10         1    0       0;          %KB Setersberg 22 kV
    23  0       0      20        0          1   10         1    0       0;          %KB Hovde 22 kB
    ];

%% branch data
%	fbus	tbus	r           x           b           rateA	rateB	rateC	ratio       angle	status
branch = [
	1       2       0.001044    0.002154 	0.0038294   100     100     100        0            0       1;  %Flesaker - Vestfossen avgr 60 kV
    2       3       0.0000178   0.0000281   0.00004742  100     100     100        0            0       1;  %Vestfossen avgr - Vestfossen 60 kV
    3       4       0.0014972   0.0379315   0       	100     100     100        0            0       1;  %Trafo: Vestfossen 60 kV - Vestfossen 22 kV 
   	2       5       0.001872    0.003862    0.0068669   100     100     100        0            0       1;  %Vestfossen avgr - Hokksund avgr 60 kV
   	5       6       0.000403    0.00083 	0.0014758   100     100     100        0            0       1;  %Hokksund avgr - Hokksund 60 kV
    6       7       0.0010279   0.0249902 	0           100     100     100        0            0       1;  %Trafo: Hokksund 60 kV - Hokksund 22 kV T1 
    6       8       0.0017088   0.0380303 	0           100     100     100        0            0       1;  %Trafo: Hokksund 60 kV - Hokksund 22 kV T2 
    5       9       0.004713    0.009722	0.0172856   100     100     100        0            0       1;  %Hokksund avgr - Skotselv avgr 60 kV
    9      10       0.001988    0.002089	0.0033505   100     100     100        0            0       1;  %Skotselv avgr - Skotselv 60 kV
   10      11       0.0039187   0.0771976  	0           100     100     100        0            0       1;  %Trafo: Skotselv 60 kV - Skotselv 22 kV
    9      12       0.004418    0.009114	0.016204    100     100     100        0            0       1;  %Skotselv avgr - Setersberg 60 kV
    1      12       0.012048    0.024852	0.0269002   100     100     100        0            0       1;  %Flesaker - Setersberg 60 kV L2
    12     13       0.0025187   0.0371786 	0           100     100     100        0            0       1;  %Trafo: Setersberg 60 kV - Setersberg 22 kV
    13     14       0.008158    0.021047	0.0021842   100     100     100        0            0       1;  %Setersberg - Dvikfoss 22 kV
    14     15       0.0051401   0.0257007  	0           100     100     100        0            0       1;  %Trafo: Dvikfoss 22 kV - Dvikfoss GE
    12     16       0.000616    0.00127 	0.0022581   100     100     100        0            0       1;  %Setersberg - Embertsfoss avgr 60 kV
    16     17       0.000955    0.00197 	0.0035024   100     100     100        0            0       1;  %Embretsfoss avgr - Embretsfoss 60 kV
    17     18       0.0011521   0.0333303 	0           100     100     100        0            0       1;  %Trafo: Embretsfoss 60 - Embretsfoss GE
    16     19       0.002480    0.005116	0.0090966   100     100     100        0            0       1;  %Embretsfoss avgr - Holgersmoen 60 kV
    19     20       0.001352    0.002130	0.0035912   100     100     100        0            0       1;  %Holgersmoen - Geithusfoss 60 kV
    20     21       0.0038667   0.0645533 	0           100     100     100        0            0       1;  %Trafo: Geithusfoss 60 - Geithusfoss GE
    19     22       0.000863    0.003992	0.0082346   100     100     100        0            0       1;  %Holgersmoen - Hovde 60 kV
    22     23       0.0026435   0.0451685	0           100     100     100        0            0       1;  %Trafo: Hovde 60 kV - Hovde 22 kV
    22     23       0.0025418   0.0462412 	0           100     100     100        0            0       1;  %Trafo: Hovde 60 kV - Hovde 22 kV
    22     24       0.009905    0.020432	0.0363269   100     100     100        0            0       1;  %Hovde - Ramfoss 60 kV
    22     24       0.009905    0.020432	0.0363269   100     100     100        0            0       1;  %Hovde - Ramfoss 60 kV
    24     26       0.0093077   0.0465385   0           100     100     100        0            0       1;  %Trafo: Ramfoss 60 - Ramfoss GE 1
    24     27       0.0093077   0.0465385   0           100     100     100        0            0       1;  %Trafo: Ramfoss 60 - Ramfoss GE 2
    24     28       0.0093077   0.0465385   0           100     100     100        0            0       1;  %Trafo: Ramfoss 60 - Ramfoss GE 3
    24     25       0.0121      0.0605      0           100     100     100        0            0       1;  %Trafo: Ramfoss 60 - Ramfoss LA
   ];

%%-----  OPF Data  -----%%
%% area data
areas = [
	1	1;
];

%% generator cost data
%	1	startup	shutdown	n	x1	y1	...	xn	yn
%	2	startup	shutdown	n	c(n-1)	...	c0
gencost = [
  ];

return;
