function [tap,kostnadsred_nettap,totale_generatortap, kostnadsred_gentap,Snett, kostnadsred_snett,investkost_KB,kostnadsred_KS,fitness,straffekost_spenning] = ...
                                                            skriv_ut_beste_resultat_tunglast(MVA,ssk,generatorer,linjer,kromo, gen_nr, gen_typ, gener,kostnadstak...
                                                            , KB_fast, KB_var, bryterf_fast, KS_ekvpris, gen_ekvpris, tap_ekvpris, Snett_ekvpris, spenningskostnad...
                                                            ,effekttap_dagens_tunglast,generatortap_dagens_tunglast,Snett_dagens_tunglast,reaktiv_prod_i_gen_dagens_tunglast...
                                                            ,generatordata_tapsberegning)


%%
%------------------INVESTERINGSKOSTNADER-----------------------------------
%
%Investeringskostnader regnes ut hvis kondensatorbatteri m installeres.
%Kostnader til drift og vedlikehold er inkludert i kostnadsberegningene.

i_kostnader = 0;

for j=1:gener
        if gen_typ(1,j)==2
            if kromo(j)~=0
                i_kostnader=i_kostnader+KB_fast+KB_var*kromo(j);
            end
        elseif gen_typ(1,j)==3
            if kromo(j)~=0
                i_kostnader=i_kostnader+KB_fast+KB_var*kromo(j)+bryterf_fast;
            end
        end
end

investkost_KB=i_kostnader;

%%
%-------KOSTNADER FOR KJP AV REAKTIV EFFEKT FRA KRAFTSTASJONER---------
%
%Kostnader ved kjp av reaktiv effekt fra sentralnettet og kraftstasjoner i
%regionalnettet beregnes. Det tas utgangspunkt i en tunglastsituasjon, og
%det m derfor beregnes hvor stor effektkostnaden er i lpet av et r. 

prod_i_gen= 0;

for j=1:gener
        if gen_typ(1,j)==1
            if kromo(j)>0
                prod_i_gen=prod_i_gen+kromo(j);
            end
        end
end

endring_prod_i_gen=reaktiv_prod_i_gen_dagens_tunglast-prod_i_gen;
kostnad_prod_i_gen=KS_ekvpris*endring_prod_i_gen;

kostnadsred_KS=kostnad_prod_i_gen;
 
%%
%-----------------Beregning av tap i generatorer-----------------------
%

totale_generatortap=0;

for i=1:gener
    if gen_typ(1,i)==1
        generator_nummer=gen_nr(1,i);
        aktiv_produksjon=generatorer(generator_nummer,2);
        reaktiv_produksjon=kromo(i);
        generatortap=tap_i_generatorer(aktiv_produksjon,reaktiv_produksjon,generator_nummer,generatordata_tapsberegning);
        totale_generatortap=totale_generatortap+generatortap; %tap i kW
    end    
end

endring_gentap=generatortap_dagens_tunglast-totale_generatortap;
totalkostnad_generatortap=endring_gentap*gen_ekvpris;

kostnadsred_gentap=totalkostnad_generatortap;

%%
%----------------------TAPSKOSTNADER OG SENTRALNETTSKOSTNADER--------------
%
%Kjrer lastflyt og henter ut verdier til beregning av kostnader.
%
%Legger frst inn verdier for reaktiv produksjon i generator-matrisen som brukes
%i lastflytberegningen.

for j=1:gener
    generatorer(gen_nr(j),3)=kromo(j);
end

%Kjrer lastflytberegning. 

[baseMVA_ut,bus_ut,gen_ut,branch_ut,success_ut,et_ut,tap_ut]=runpf_mod(MVA,ssk,generatorer,linjer);

%Lagrer informasjon om konvergens i lastflyten

success=success_ut;

%Beregner tapskostnader

tap=tap_ut;
endring_nettap=effekttap_dagens_tunglast-tap;
tapskost=tap_ekvpris*endring_nettap;

kostnadsred_nettap=tapskost;

%Beregner sentralnettskostnader

Snett=0;

if gen_ut(1,3)>0
    Snett=gen_ut(1,3);
end

endring_Snett=Snett_dagens_tunglast-Snett;
Snett_kost=endring_Snett*Snett_ekvpris;

kostnadsred_snett=Snett_kost;
      
ssk_matrise=size(ssk);
antall_ssk=ssk_matrise(1,1);

%Finner antall samleskinner hvor spenningen er utenfor grensene

spenningsfeil=0;
    
for a=1:antall_ssk
    if bus_ut(a,8)>bus_ut(a,12) || bus_ut(a,8)<bus_ut(a,13)
       spenningsfeil=spenningsfeil+1;
    end
end

%Beregner totale kostnader. Hvis kostnadene er lavere enn kostnadstaket og
%hvis lastflyten konvergerte blir fitnessverdien beregnet. Hvis ikke settes
%fitnessverdien til null.

kostnadsreduksjon=Snett_kost+tapskost+totalkostnad_generatortap+kostnad_prod_i_gen-i_kostnader;

straffekost_spenning=spenningsfeil*spenningskostnad;

if success==1  
    fitness=kostnadsreduksjon/1000000-straffekost_spenning+kostnadstak;
else
    fitness=0;
end
    
return;
