%
%%------------STARTER DEN GENETISKE ALGORITMEN-----------------------------%
%
%Dette er en genetisk algoritme som optimaliserer reaktiv innmating.
%

%Legger inn data fra brukerdefinerte input-filer. 

[MVA,ssk,generatorer,linjer]=kongsbergnett; 
[variasjon_aar_last,variasjon_dogn_last,lastkategori,variasjon_aar_produksjon]=kongsbergnett_variasjon; 
[generatordata_tapsberegning]=kongsbergnett_generatordata;
[GA_parametre, kostnadsparametre, dagens_drift,generatortyper]=kongsbergnett_inndata;

disp(' ')
disp('-----------------------Genetisk algoritme for optimalisering av reaktiv effekt -------------------')
disp(' ')
disp('Oversikt over hvilke typer optimalisering programmet kan utfre:')
disp(' ')
disp('---------------------Drift uten installasjon av nye kondensatorbatterier--------------')
disp(' ')
disp('1 = optimalisering av drift ved tunglast uten installasjon av nye kondensatorbatterier')
disp('2 = optimalisering av drift utenfor tunglast uten nye kondensatorbatterier')

disp(' ')
disp('---------------------Installasjon av nye kondensatorbatterier-------------------------')
disp(' ')
disp('3 = optimalisering av ytelse og plassering av kondensatorbatterier')
disp('4 = optimalisering av drift og kobling av nye kondensatorbatterier i tunglastperioden')
disp('5 = optimalisering av drift og kobling av nye kondensatorbatterier utenfor tunglastperioden')
disp(' ')
type_optimalisering = input('Hva slags type optimalisering skal gjres? Tast inn tall mellom 1 og 5');
disp(' ')

if type_optimalisering ==1
    maaned=input('Hvilken mned skal driften optimaliseres for?');
    time=input('Hvilken time er topplasttimen?');
    
    GA_optimal_drift_tunglast(MVA,ssk,generatorer,linjer,GA_parametre, kostnadsparametre, dagens_drift,generatortyper...
                                ,generatordata_tapsberegning,variasjon_aar_last,variasjon_dogn_last,lastkategori,variasjon_aar_produksjon,maaned,time);

elseif type_optimalisering==2
    maaned=input('Hvillken mned skal driften optimaliseres for?');
    time=input('Hvilken time skal driften optimaliseres for?');
    disp(' ')
    GA_optimal_drift_utenfor_tunglast(MVA,ssk,generatorer,linjer,GA_parametre,generatortyper...
        ,generatordata_tapsberegning,variasjon_aar_last,variasjon_dogn_last,lastkategori,variasjon_aar_produksjon,maaned,time);

elseif type_optimalisering==3
    maaned=input('Hvilken mned skal brukes for dimensjonering av kondensatorbatterier?');
    time=input('Hvilken time skal bruks for dimensjonering av kondensatorbatterier?');
    [resultat,y,x]=GA_optimal_KB_dimensjonering(MVA,ssk,generatorer,linjer,GA_parametre, kostnadsparametre, dagens_drift,generatortyper...
                            ,generatordata_tapsberegning,variasjon_aar_last,variasjon_dogn_last,lastkategori,variasjon_aar_produksjon,maaned,time);
                        
elseif type_optimalisering==4
    disp('Det antas at alle nye kondensatorbatterier er innkoblet i tunglastperioden')
    disp(' ')
    antall_KB=input('Hvor mange nye kondensatorbatterier skal installeres?');
    disp(' ')
    KB=zeros(2,antall_KB);
    for i=1:antall_KB
        disp('Legg inn data for KB nr')
        disp(i)
        disp(' ')
        KB(1,i)=input('Legg inn generatornummer (raden til KB i generatormatrisen i filen med nettdata)');
        disp(' ')
        KB(2,i)=input('Legg inn batteriets strrelse');
        disp(' ')
    end
    mnd=input('Hvilken mned skal drift og kobling optimaliseres for?');
    time=input('Hvilken time skal drift og kobling optimaliseres for?');
    disp('')
    GA_optimal_KB_tunglast(MVA,ssk,generatorer,linjer,GA_parametre, kostnadsparametre, dagens_drift,generatortyper...
                            ,generatordata_tapsberegning,variasjon_aar_last,variasjon_dogn_last,lastkategori,variasjon_aar_produksjon,mnd,time,KB);                        
elseif type_optimalisering==5
    antall_KB=input('Hvor mange nye kondensatorbatterier skal installeres?');
    disp(' ')
    KB=zeros(2,antall_KB);
    for i=1:antall_KB
        disp('Legg inn data for KB nr')
        disp(i)
        disp(' ')
        KB(1,i)=input('Legg inn generatornummer (raden til KB i generatormatrisen i filen med nettdata)');
        disp(' ')
        KB(2,i)=input('Legg inn batteriets strrelse');
        disp(' ')
    end
    mnd=input('Hvilken mned skal drift og kobling optimaliseres for?');
    time=input('Hvilken time skal drift og kobling optimaliseres for?');
    disp('')
    GA_optimal_KB_utenfor_tunglast(MVA,ssk,generatorer,linjer,GA_parametre,generatortyper...
        ,generatordata_tapsberegning,variasjon_aar_last,variasjon_dogn_last,lastkategori,variasjon_aar_produksjon,mnd,time,KB);

else 
     
    disp('Du m velge et heltall mellom 1 og 5')
    disp('')
end

